/*
 * Simple mysql client pager that shows tables in colour, rather than in boxes.
 * David Leonard, 2001. Public domain.
 */

#include <stdio.h>

void
process(c)
	char c;
{
	static enum { OUTSIDE, DIV1, TITLE, DIV2, ROW, DIV3 } 
		linestate = OUTSIDE;
	static int pos = 0;
	static int col = 0;
	static int ncols = 0;
	static int cpos[1024] = { 0 };

	if (pos == 0 && linestate == OUTSIDE && c == '+') {
		linestate = DIV1;
		ncols = 0;
	} else if (pos == 0 && linestate == ROW && c == '+')
		linestate = DIV3;

	if (linestate == DIV1 && pos > 0 && c == '+') 
		cpos[++ncols] = pos;

	if (linestate == OUTSIDE)
		putchar(c);
	else if (linestate == DIV1 || linestate == DIV2 || linestate == DIV3)
		/* nothing */;
	else {
		if (pos == cpos[col]) {
			putchar(' ');
		} else if (pos == cpos[col] + 1 && col < ncols) {
			printf("\033[%dm", linestate == TITLE ? 46 : 47);
		} else if (pos == cpos[col + 1] - 1) {
			printf("\033[m");
			col++;
		} else 
			putchar(c);
	}

	if (c == '\n') {
		pos = 0; col = 0;
		switch (linestate) {
		case OUTSIDE: break;
		case DIV1:  linestate = TITLE; break;
		case TITLE: linestate = DIV2; break;
		case DIV2:  linestate = ROW; break;
		case DIV3:  linestate = OUTSIDE; break;
		}
	} else pos++;
}

int
main()
{
	int ch;

	while ((ch = getchar()) != EOF)
		process(ch);
	exit(0);
}
